//
// foundation/base/grid
//

// variables
$columns: 12;
$infix: '-';

$gutters: (
  "xl": $base-spacing-unit * 8,
  "lg": $base-spacing-unit * 4,
  "md": $base-spacing-unit * 2,
  "sm": $base-spacing-unit,
  "xs": $base-spacing-unit * 0.5,
  "null": 0
);
//

.row {
  @include make-row;
}

.gutter {
  @include make-gutter;
}

.full-width {
  width: 100%;
}

@each $gutter, $gutter-value in $gutters {
  .gutter-#{$gutter} {
    margin-left: calc(#{$gutter-value} / -2);
    margin-right: calc(#{$gutter-value} / -2);

    > * {
      padding-left: calc(#{$gutter-value} / 2);
      padding-right: calc(#{$gutter-value} / 2);
    }
  }
}

@each $breakpoint in map-keys($breakpoints) {
  @include mq(#{$breakpoint}) {

    @if(map-get($breakpoints, $breakpoint) != 0) {
      $breakpoint: -#{$breakpoint};
    } @else {
      $breakpoint: null;
    }

    .col#{$breakpoint} {
      flex-basis: 0;
      flex-grow: 1;
      max-width: 100%;

      // start: layout [reference to components/article.scss]
      .mod_article .row > &.block {
        margin-bottom: 0;
      }
      // end;
    }

    .col-auto#{$breakpoint} {
      flex: 0 0 auto;
      width: auto;
      max-width: 100%; // Reset earlier grid tiers

      // start: layout [reference to components/article.scss]
      .mod_article .row > &.block {
        margin-bottom: 0;
      }
      // end;
    }

    .col-block#{$breakpoint} {
      position: relative;
      width: 100%;
      min-height: 1px;
    }

    @for $column from 1 through $columns {
      @for $columns from $column through $columns {
        $col-width: $column / $columns * 100%;
        @if($col-width != 100%) {

          // columns (width)
          .col-#{$column}-#{$columns}#{$breakpoint} {
            flex: 0 0 $col-width;
            max-width: $col-width;

            // start: layout [reference to components/article.scss]
            .mod_article .row > &.block {
              margin-bottom: 0;
            }
            // end;
          }

          // offset (margin-left)
          .off-#{$column}-#{$columns}#{$breakpoint} {
            margin-left: $col-width;
          }

          .off--#{$column}-#{$columns}#{$breakpoint} {
            margin-left: -$col-width;
          }
        }
      }
    }

    @each $gutter, $gutter-value in $gutters {
      .gutter-#{$gutter}#{$breakpoint} {
        margin-left: calc(#{$gutter-value} / -2);
        margin-right: calc(#{$gutter-value} / -2);

        > * {
          padding-left: calc(#{$gutter-value} / 2);
          padding-right: calc(#{$gutter-value} / 2);
        }
      }
    }
  }
}
